VSTGUI: CNinePartTiledBitmap Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Loading...
Searching...
No Matches
Public Member Functions | List of all members
CNinePartTiledBitmap Class Reference
New classes » Version 4.0

a nine-part tiled bitmap More...

`#include <cbitmap.h>`

Inheritance diagram for CNinePartTiledBitmap:

## Public Member Functions
| CNinePartTiledBitmap (const CResourceDescription &desc, const CNinePartTiledDescription &offsets)
| CNinePartTiledBitmap (const PlatformBitmapPtr &platformBitmap, const CNinePartTiledDescription &offsets)
| ~CNinePartTiledBitmap () noexcept override=default
Public Member Functions inherited from CBitmap
| CBitmap (const CResourceDescription &desc)
| Create an image from a resource identifier.
| CBitmap (CCoord width, CCoord height)
| Create an image with a given size.
| CBitmap (CPoint size, double scaleFactor=1.)
| Create an image with a given size and scale factor.
| CBitmap (const PlatformBitmapPtr &platformBitmap)
| ~CBitmap () noexcept override=default
CCoord | getWidth () const
| get the width of the image
CCoord | getHeight () const
| get the height of the image
CPoint | getSize () const
| get size of image
bool | isLoaded () const
| check if image is loaded
const CResourceDescription & | getResourceDescription () const
PlatformBitmapPtr | getPlatformBitmap () const
void | setPlatformBitmap (const PlatformBitmapPtr &bitmap)
bool | addBitmap (const PlatformBitmapPtr &platformBitmap)
PlatformBitmapPtr | getBestPlatformBitmapForScaleFactor (double scaleFactor) const
const_iterator | begin () const
const_iterator | end () const
Public Member Functions inherited from ReferenceCounted< std::atomic< int32_t > >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
| ReferenceCounted ()=default
| ReferenceCounted (const ReferenceCounted &)
virtual | ~ReferenceCounted () noexcept=default
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount

## Part Offsets
CNinePartTiledDescription | offsets
void | setPartOffsets (const CNinePartTiledDescription &partOffsets)
const CNinePartTiledDescription & | getPartOffsets () const
void | draw (CDrawContext *context, const CRect &rect, const CPoint &offset=CPoint(0, 0), float alpha=1.f) override

## Additional Inherited Members
Public Types inherited from CBitmap
using | BitmapVector = std::vector<PlatformBitmapPtr>
using | const_iterator = BitmapVector::const_iterator
| CBitmap ()
CResourceDescription | resourceDesc
BitmapVector | bitmaps

## Detailed Description

a nine-part tiled bitmap

A nine-part tiled bitmap is tiled in nine parts which are drawing according to its part offsets:

- top left corner
- top right corner
- bottom left corner
- bottom right corner
- top edge, repeated as often as necessary and clipped appropriately
- left edge, dto.
- right edge, dto.
- bottom edge, dto.
- center, repeated horizontally and vertically as often as necessary

    |------------------------------------------------------------------------------------------------|
    | Top-Left Corner    |         <----        Top Edge        ---->          |    Top-Right Corner |
    |--------------------|-----------------------------------------------------|---------------------|
    |         ^          |                         ^                           |          ^          |
    |         |          |                         |                           |          |          |
    |     Left Edge      |         <----         Center         ---->          |      Right Edge     |
    |         |          |                         |                           |          |          |
    |         v          |                         v                           |          v          |
    |--------------------|-----------------------------------------------------|---------------------|
    | Bottom-Left Corner |         <----       Bottom Edge      ---->          | Bottom-Right Corner |
    |------------------------------------------------------------------------------------------------|

## Constructor & Destructor Documentation

## ◆ CNinePartTiledBitmap() [1/2]

CNinePartTiledBitmap | ( | const CResourceDescription & | desc,
|  | const CNinePartTiledDescription & | offsets )

## ◆ CNinePartTiledBitmap() [2/2]

CNinePartTiledBitmap | ( | const PlatformBitmapPtr & | platformBitmap,
|  | const CNinePartTiledDescription & | offsets )

## ◆ ~CNinePartTiledBitmap()

~CNinePartTiledBitmap | ( |  | ) |
| overridedefaultnoexcept

## Member Function Documentation

## ◆ draw()

void draw | ( | CDrawContext * | context,
|  | const CRect & | rect,
|  | const CPoint & | offset = CPoint (0, 0),
|  | float | alpha = 1.f )
| overridevirtual

Reimplemented from CBitmap.

## ◆ getPartOffsets()

const CNinePartTiledDescription & getPartOffsets | ( |  | ) | const
| inline

## ◆ setPartOffsets()

void setPartOffsets | ( | const CNinePartTiledDescription & | partOffsets | ) |
| inline

## Member Data Documentation

## ◆ offsets

CNinePartTiledDescription offsets
| protected

The documentation for this class was generated from the following files:

- cbitmap.h
- cbitmap.cpp